# Create an order asynchronously Note: This operation is only available if you have the Orders feature enabled. If you are an existing Zuora Subscribe and Amend customer, we recommend you enable Orders Harmonization to access the Orders feature. With Orders, you can access both existing functions for subscription and billing management and the new features on Zuora Billing. Note: The Order Line Items feature is now generally available to all Zuora customers. You need to enable the Orders feature to access the Order Line Items feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on Orders will have the Order Line Items feature enabled by default. In the case where a normal "Create an order" operation call will time out, use this operation instead to create an order asynchronously. A job will be creating the order in the back end; the job ID will be returned for tracking the job status and result. Note that this operation doesn't support auto-refund and invoice write-off during subscription cancellation. Use the "Create an order" operation instead. The limit of orders allowed on a subscription is 1000. The limit of order line items allowed in an order is 100. Zuora has the following limits on the Orders synchronous API to prevent performance degradation: * Up to 50 subscriptions are allowed in a single Create an order or Preview an order operation call. * Up to 50 order actions are allowed in a single Create an order or Preview an order operation call. * Up to 50 order actions are allowed on a single subscription in a Create an order or Preview an order operation call. If you have an Order that exceeds any limits of the above, Zuora recommends you use the following asynchronous API operations: * Create an order asynchronously * Preview an order asynchronously * Retrieve the status and response of a job for checking the status of the asynchronous API operations Zuora has the following limits on the Orders asynchronous API operations to prevent performance degradation: * Up to 300 subscriptions are allowed in a single Create an order asynchronously or Preview an order asynchronously operation call. * Up to 300 order actions are allowed in a single Create an order asynchronously or Preview an order asynchronously operation call. * Up to 300 order actions are allowed on a single subscription in a Create an order asynchronously or Preview an order asynchronously operation call. Endpoint: POST /v1/async/orders Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Query parameters: - `returnIds` (boolean) Specify whether to return IDs for the Get job status and response operation. If you set this query parameter to true, the corresponding IDs, which are associated with the numbers returned in this operation, can be returned in the "Get job status and response" response body. ## Request fields (application/json): - `category` (string) Category of the order to indicate a product sale or return. Default value is NewSales. Enum: "NewSales", "Return" - `customFields` (object) Container for custom fields of an Order object. - `description` (string) A description of the order. - `existingAccountId` (string) The account ID under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field. Note: You can specify either the existingAccountNumber or existingAccountId field, but not both. - `existingAccountNumber` (string) The account number under which this order will be created. This field sets the default invoice owner account and subscription owner account for any new subscriptions in the order. To override these defaults for individual subscriptions, use the subscriptionOwnerAccountNumber and invoiceOwnerAccountNumber nested fields in the subscriptions field. Example: "A00000097" - `externallyManagedBy` (string) An enum field on the Subscription object to indicate the name of a third-party store. This field is used to represent subscriptions created through third-party stores. Enum: "Amazon", "Apple", "Google", "Roku" - `newAccount` (object) The information of the new account to be created with the order. To create the new account, either a creditCard structure or the hpmCreditCardPaymentMethodId field (but not both) should be provided. The one provided becomes the default payment method for this account. If the credit card information is declined or can't be verified, then the account is not created. - `newAccount.accountNumber` (string) - `newAccount.additionalEmailAddresses` (string) List of additional email addresses to receive emailed invoices. Values should be a comma-separated list of email addresses. - `newAccount.allowInvoiceEdit` (boolean) Indicates if associated invoices can be edited. Values are: * true * false (default) - `newAccount.autoPay` (boolean) Specifies whether future payments are to be automatically billed when they are due. Possible values are true, false. - `newAccount.batch` (string) Note: By default, you have 50 configurable account batches. To increase the limit to 200 batches, you must have the Performance Booster Elite package. - `newAccount.billCycleDay` (integer, required) Day of the month that the account prefers billing periods to begin on. If set to 0, the bill cycle day will be set as "AutoSet". - `newAccount.billToContact` (object, required) Contact details associated with an account. - `newAccount.billToContact.address1` (string) First line of the contact's address. This is often a street address or a business name. - `newAccount.billToContact.address2` (string) Second line of the contact's address. - `newAccount.billToContact.city` (string) City of the contact's address. - `newAccount.billToContact.contactDescription` (string) A description for the contact. - `newAccount.billToContact.country` (string) Country; must be a valid country name or abbreviation. If using Zuora Tax, you must specify a country in the bill-to contact to calculate tax. - `newAccount.billToContact.county` (string) County of the contact's address. - `newAccount.billToContact.fax` (string) Fax number of the contact. - `newAccount.billToContact.firstName` (string, required) First name of the contact. - `newAccount.billToContact.homePhone` (string) Home phone number of the contact. - `newAccount.billToContact.lastName` (string, required) Last name of the contact. - `newAccount.billToContact.mobilePhone` (string) Mobile phone number of the contact. - `newAccount.billToContact.nickname` (string) Nickname of the contact. - `newAccount.billToContact.otherPhone` (string) Additional phone number of the contact. Use the otherPhoneType field to specify the type of phone number. - `newAccount.billToContact.otherPhoneType` (string) Specifies the type of phone number in the otherPhone field. Enum: "Work", "Mobile", "Home", "Other" - `newAccount.billToContact.personalEmail` (string) Personal email address of the contact. - `newAccount.billToContact.postalCode` (string) ZIP code or other postal code of the contact's address. - `newAccount.billToContact.state` (string) State or province of the contact's address. - `newAccount.billToContact.taxRegion` (string,null) Region defined in your taxation rules. Only applicable if you use Zuora Tax. - `newAccount.billToContact.workEmail` (string) Business email address of the contact. - `newAccount.billToContact.workPhone` (string) Business phone number of the contact. - `newAccount.communicationProfileId` (string) - `newAccount.creditCard` (object) Default payment method associated with an account. Only credit card payment methods are supported. - `newAccount.creditCard.cardHolderInfo` (object) Information about the cardholder of a credit card payment method associated with an account. If you do not provide information about the cardholder, Zuora uses the account's bill-to contact. - `newAccount.creditCard.cardHolderInfo.addressLine1` (string) First line of the cardholder's address. - `newAccount.creditCard.cardHolderInfo.addressLine2` (string) Second line of the cardholder's address. - `newAccount.creditCard.cardHolderInfo.cardHolderName` (string) Full name of the cardholder as it appears on the card. For example, "John J Smith", 50 characters or less. The value must consist only of US-ASCII characters and must not include special characters. - `newAccount.creditCard.cardHolderInfo.city` (string) City of the cardholder's address. It is recommended to provide the city and country information when creating a payment method. The information will be used to process payments. If the information is not provided during payment method creation, the city and country data will be missing during payment processing. - `newAccount.creditCard.cardHolderInfo.country` (string) Country of the cardholder's address. The value of this field must be a valid country name or abbreviation. It is recommended to provide the city and country information when creating a payment method. The information will be used to process payments. If the information is not provided during payment method creation, the city and country data will be missing during payment processing. - `newAccount.creditCard.cardHolderInfo.email` (string) Email address of the cardholder. - `newAccount.creditCard.cardHolderInfo.phone` (string) Phone number of the cardholder. - `newAccount.creditCard.cardHolderInfo.state` (string) State or province of the cardholder's address. - `newAccount.creditCard.cardHolderInfo.zipCode` (string) ZIP code or other postal code of the cardholder's address. - `newAccount.creditCard.cardNumber` (string) Card number. Once set, you cannot update or query the value of this field. The value of this field is only available in masked format. For example, XXXX-XXXX-XXXX-1234 (hyphens must not be used when you set the credit card number). - `newAccount.creditCard.cardType` (string) Type of card. Enum: "Visa", "MasterCard", "AmericanExpress", "Discover", "JCB", "Diners", "CUP", "Maestro", "Electron", "AppleVisa", "AppleMasterCard", "AppleAmericanExpress", "AppleDiscover", "AppleJCB", "Elo", "Hipercard", "Naranja", "Nativa", "TarjetaShopping", "Cencosud", "Argencard", "Cabal" - `newAccount.creditCard.expirationMonth` (integer) Expiration date of the card. - `newAccount.creditCard.expirationYear` (integer) Expiration year of the card. - `newAccount.creditCard.securityCode` (string) CVV or CVV2 security code of the card. To ensure PCI compliance, Zuora does not store the value of this field. - `newAccount.creditMemoTemplateId` (string) Note: This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. The unique ID of the credit memo template, configured in Billing Settings > Manage Billing Document Configuration through the Zuora UI. For example, 2c92c08a6246fdf101626b1b3fe0144b. - `newAccount.crmId` (string) - `newAccount.currency` (string, required) 3 uppercase character currency code. For payment method authorization, if the paymentMethod > currencyCode field is specified, currencyCode is used. Otherwise, this currency field is used for payment method authorization. If no currency is specified for the account, the default currency of the account is then used. - `newAccount.customFields` (object) Container for custom fields of an Account object. - `newAccount.customerServiceRepName` (string) Name of the account's customer service representative, if applicable. - `newAccount.debitMemoTemplateId` (string) Note: This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. The unique ID of the debit memo template, configured in Billing Settings > Manage Billing Document Configuration through the Zuora UI. For example, 2c92c08d62470a8501626b19d24f19e2. - `newAccount.hpmCreditCardPaymentMethodId` (string) The ID of the payment method associated with this account. The payment method specified for this field will be set as the default payment method of the account. If the autoPay field is set to true, you must provide the credit card payment method ID for either this field or the creditCard field, but not both. For the Credit Card Reference Transaction payment method, you can specify the payment method ID in this field or use the paymentMethod field to create a CC Reference Transaction payment method for an account. - `newAccount.invoiceDeliveryPrefsEmail` (boolean) Specifies whether to turn on the invoice delivery method 'Email' for the new account. Values are: * true (default). Turn on the invoice delivery method 'Email' for the new account. * false. Turn off the invoice delivery method 'Email' for the new account. - `newAccount.invoiceDeliveryPrefsPrint` (boolean) Specifies whether to turn on the invoice delivery method 'Print' for the new account. Values are: * true. Turn on the invoice delivery method 'Print' for the new account. * false (default). Turn off the invoice delivery method 'Print' for the new account. - `newAccount.invoiceTemplateId` (string) - `newAccount.name` (string, required) - `newAccount.notes` (string) - `newAccount.organizationLabel` (string) Name of the organization that the account belongs to. This field is only required when you have already turned on Multi-Org feature. - `newAccount.parentId` (string) Identifier of the parent customer account for this Account object. Use this field if you have Customer Hierarchy enabled. - `newAccount.partnerAccount` (boolean) Whether the customer account is a partner, distributor, or reseller. You can set this field to true if you have business with distributors or resellers, or operating in B2B model to manage numerous subscriptions through concurrent API requests. After this field is set to true, the calculation of account metrics is performed asynchronously during operations such as subscription creation, order changes, invoice generation, and payments. Note: This field is available only if you have the Reseller Account feature enabled. - `newAccount.paymentGateway` (string) - `newAccount.paymentMethod` (object) Payment method information associated with an account. - `newAccount.paymentTerm` (string) Note: If you want to specify a payment term when creating a new account, you must set a value in this field. If you do not set a value in this field, Zuora will use the default value set in Billing Settings > Payment Terms from Zuora UI. - `newAccount.purchaseOrderNumber` (string) The number of the purchase order associated with this account. Purchase order information generally comes from customers. - `newAccount.salesRep` (string) The name of the sales representative associated with this account, if applicable. - `newAccount.sequenceSetId` (string,null) The ID of the sequence set to assign to the customer account. The billing documents to generate for this account will adopt the prefix and starting document number configured in the sequence set. - `newAccount.shipToContact` (object) Contact details associated with an account. - `newAccount.shipToContact.country` (string) Country; must be a valid country name or abbreviation. - `newAccount.shipToSameAsBillTo` (boolean) Whether the ship-to contact and bill-to contact are the same entity. The created account has the same bill-to contact and ship-to contact entity only when all the following conditions are met in the request body: - This field is set to true. - A bill-to contact is specified. - No ship-to contact is specified. - `newAccount.soldToContact` (object) Contact details associated with an account. - `newAccount.soldToContact.country` (string) Country; must be a valid country name or abbreviation. If using Zuora Tax, you must specify a country in the sold-to contact to calculate tax. A bill-to contact may be used if no sold-to contact is provided. - `newAccount.soldToSameAsBillTo` (boolean) Whether the sold-to contact and bill-to contact are the same entity. The created account has the same bill-to contact and sold-to contact entity only when all the following conditions are met in the request body: - This field is set to true. - A bill-to contact is specified. - No sold-to contact is specified. - `newAccount.taxInfo` (object) Information about the tax exempt status of a customer account. - `newAccount.taxInfo.VATId` (string) EU Value Added Tax ID. Note: This feature is in Limited Availability. If you wish to have access to the feature, submit a request at [Zuora Global Support](https://support.zuora.com). - `newAccount.taxInfo.companyCode` (string) Unique code that identifies a company account in Avalara. Use this field to calculate taxes based on origin and sold-to addresses in Avalara. Note: This feature is in Limited Availability. If you wish to have access to the feature, submit a request at [Zuora Global Support](https://support.zuora.com). - `newAccount.taxInfo.exemptCertificateId` (string) ID of the customer tax exemption certificate. Applicable if you use Zuora Tax or Connect tax engines. - `newAccount.taxInfo.exemptCertificateType` (string) Type of tax exemption certificate that the customer holds. Applicable if you use Zuora Tax or Connect tax engines. - `newAccount.taxInfo.exemptDescription` (string) Description of the tax exemption certificate that the customer holds. Applicable if you use Zuora Tax or Connect tax engines. - `newAccount.taxInfo.exemptEffectiveDate` (string) Date when the customer tax exemption starts, in YYYY-MM-DD format. Applicable if you use Zuora Tax or Connect tax engines. - `newAccount.taxInfo.exemptExpirationDate` (string) Date when the customer tax exemption expires, in YYYY-MM-DD format. Applicable if you use Zuora Tax or Connect tax engines. - `newAccount.taxInfo.exemptIssuingJurisdiction` (string) Jurisdiction in which the customer tax exemption certificate was issued. - `newAccount.taxInfo.exemptStatus` (string) Status of the account tax exemption. Applicable if you use Zuora Tax or Connect tax engines. Required if you use Zuora Tax. Enum: "No", "Yes", "PendingVerification" - `orderDate` (string, required) The date when the order is signed. All the order actions under this order will use this order date as the contract effective date if the contract effective date field is skipped or its value is left as null. Example: "2024-07-01" - `orderLineItems` (array) [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) are non subscription based items created by an Order, representing transactional charges such as one-time fees, physical goods, or professional service charges that are not sold as subscription services. With the Order Line Items feature enabled, you can now launch non-subscription and unified monetization business models in Zuora, in addition to subscription business models. If you do not have the Create Order Line Items Without Product Catalog billing permission, you can only create order line items from existing products by specifying the product rate plan charge ID in the productRatePlanChargeId field. For more information about billing permissions, see Billing Roles. Note: The [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) feature is now generally available to all Zuora customers. You need to enable the [Orders](https://knowledgecenter.zuora.com/BC_Subscription_Management/Orders/AA_Overview_of_Orders#Orders) feature to access the [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AA_Overview_of_Order_Line_Items) feature. As of Zuora Billing Release 313 (November 2021), new customers who onboard on [Orders](https://docs.zuora.com/en/zuora-billing/manage-accounts-subscriptions-and-non-subscriptions/manage-subscription-transactions/orders/orders-introduction/overview-of-orders) will have the [Order Line Items](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items) feature enabled by default. - `orderLineItems.UOM` (string) Specifies the units to measure usage. - `orderLineItems.accountingCode` (string) The accounting code for the Order Line Item. - `orderLineItems.adjustmentLiabilityAccountingCode` (string) The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). - `orderLineItems.adjustmentRevenueAccountingCode` (string) The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). - `orderLineItems.amountPerUnit` (number) The actual charged amount per unit for the Order Line Item. If you set the inlineDiscountType, inlineDiscountPerUnit, and listPricePerUnit fields, the system will automatically generate the amountPerUnit field. You shall not set the amountPerUnit field by yourself. - `orderLineItems.billTargetDate` (string) The target date for the Order Line Item to be picked up by bill run for billing. - `orderLineItems.billTo` (string) The ID of the bill-to contact of an order line item. Specify an existing contact under the billing account as the bill-to contact of the order line item. The billing account is the order account. Note: If an order's category is set to Return in a return Order Line Item, it will inherit the original Order Line Item's billTo contact automatically. You cannot specify a different value. - `orderLineItems.billingRule` (string) The billing rule for the Order Line Item. Enum: "TriggerWithoutFulfillment", "TriggerAsFulfillmentOccurs" - `orderLineItems.contractAssetAccountingCode` (string) The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). - `orderLineItems.contractLiabilityAccountingCode` (string) The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). - `orderLineItems.contractRecognizedRevenueAccountingCode` (string) The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). - `orderLineItems.currency` (string) The currency for the order line item. You can specify a currency when creating an order line item through the "Create an order" operation. - `orderLineItems.customFields` (object) Container for custom fields of an Order Line Item object. - `orderLineItems.deferredRevenueAccountingCode` (string) The deferred revenue accounting code for the Order Line Item. - `orderLineItems.description` (string) The description of the Order Line Item. - `orderLineItems.excludeItemBillingFromRevenueAccounting` (boolean) The flag to exclude Order Line Item related invoice items, invoice item adjustments, credit memo items, and debit memo items from revenue accounting. Note: This field is only available if you have the Order to Revenue or [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration) feature enabled. - `orderLineItems.excludeItemBookingFromRevenueAccounting` (boolean) The flag to exclude Order Line Item from revenue accounting. Note: This field is only available if you have the Order to Revenue or [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration) feature enabled. - `orderLineItems.inlineDiscountPerUnit` (number) Use this field in accordance with the inlineDiscountType field, in the following manner: * If the inlineDiscountType field is set as Percentage, this field specifies the discount percentage for each unit of the order line item. For exmaple, if you specify 5 in this field, the discount percentage is 5%. * If the inlineDiscountType field is set as FixedAmount, this field specifies the discount amount on each unit of the order line item. For exmaple, if you specify 10 in this field, the discount amount on each unit of the order line item is 10. Once you set the inlineDiscountType, inlineDiscountPerUnit, and listPricePerUnit fields, the system will automatically generate the amountPerUnit field. You shall not set the amountPerUnit field by yourself. - `orderLineItems.inlineDiscountType` (string) Use this field to specify the inline discount type, which can be Percentage, FixedAmount, or None. The default value is Percentage. Use this field together with the inlineDiscountPerUnit field to specify inline discounts for order line items. The inline discount is applied to the list price of an order line item. Once you set the inlineDiscountType, inlineDiscountPerUnit, and listPricePerUnit fields, the system will automatically generate the amountPerUnit field. You shall not set the amountPerUnit field by yourself. Enum: "Percentage", "FixedAmount", "None" - `orderLineItems.isAllocationEligible` (boolean) This field is used to identify if the charge segment is allocation eligible in revenue recognition. Note: The field is only available if you have the Order to Revenue feature enabled. To enable this field, submit a request at Zuora Global Support. - `orderLineItems.isUnbilled` (boolean) This field is used to dictate how to perform the accounting during revenue recognition. Note: The field is only available if you have the Order to Revenue feature enabled. To enable this field, submit a request at Zuora Global Support. - `orderLineItems.itemCategory` (string) The category for the Order Line Item, to indicate a product sale or return. Enum: "Sales", "Return" - `orderLineItems.itemName` (string) The name of the Order Line Item. - `orderLineItems.itemNumber` (string) The number of the Order Line Item. Use this field to specify a custom item number for your Order Line Item. If you are to use this field, you must set all the item numbers in an order when there are several order line items in the order. - `orderLineItems.itemState` (string) The state of an Order Line Item. If you want to generate billing documents for order line items, you must set this field to SentToBilling. For invoice preview, you do not need to set this field. See [State transitions for an order, order line item, and fulfillment](https://knowledgecenter.zuora.com/Billing/Subscriptions/Orders/Order_Line_Items/AB_Order_Line_Item_States_and_Order_States) for more information. Enum: "Executing", "Booked", "SentToBilling", "Complete", "Cancelled" - `orderLineItems.itemType` (string) The type of the Order Line Item. Enum: "Product", "Fee", "Services" - `orderLineItems.listPricePerUnit` (number) The list price per unit for the Order Line Item. - `orderLineItems.originalOrderLineItemNumber` (string) The number of the original sale order line item for a return order line item. - `orderLineItems.originalOrderNumber` (string) The number of the original sale order for a return order line item. - `orderLineItems.ownerAccountNumber` (string) Use this field to assign an existing account as the owner of an order line item. - `orderLineItems.productCode` (string) The product code for the Order Line Item. - `orderLineItems.productRatePlanChargeId` (string) ID of a product rate plan charge. Only one-time charges are supported. If you do not have the Create Order Line Items Without Product Catalog billing permission, you must specify this field to create the order line item from an existing product rate plan charge. - `orderLineItems.purchaseOrderNumber` (string) Used by customers to specify the Purchase Order Number provided by the buyer. - `orderLineItems.quantity` (number) The quantity of units, such as the number of authors in a hosted wiki service. - `orderLineItems.recognizedRevenueAccountingCode` (string) The recognized revenue accounting code for the Order Line Item. - `orderLineItems.relatedSubscriptionNumber` (string) Use this field to relate an order line item to a subscription when you create the order line item. * To relate an order line item to a new subscription which is yet to create in the same "Create an order" call, use this field in combination with the subscriptions > subscriptionNumber field in the "Create an order" operation. Specify this field to the same value as that of the subscriptions > subscriptionNumber field when you make the "Create an order" call. * To relate an order line item to an existing subscription, specify this field to the subscription number of the existing subscription. - `orderLineItems.revenueRecognitionRule` (string) The Revenue Recognition rule for the Order Line Item. - `orderLineItems.revenueRecognitionTiming` (string) Specifies the type of revenue recognition timing. Predefined options are listed as enum values in this API Reference. Other options might also be avaliable depending on the revenue recognition policy configuration in the Zuora Billing UI. Note: This field is only available if you have the Order to Revenue feature enabled. Enum: "Upon Billing Document Posting Date", "Upon Order Activation Date" - `orderLineItems.revenueAmortizationMethod` (string) Specifies the type of revenue amortization method. Predefined options are listed as enum values in this API Reference. Other options might also be avaliable depending on the revenue recognition policy configuration in the Zuora Billing UI. Note: This field is only available if you have the Order to Revenue feature enabled. Enum: "Immediate", "Ratable Using Start And End Dates" - `orderLineItems.invoiceGroupNumber` (string,null) The number of the invoice group associated with the order line item. After enabling the Invoice Grouping feature, you can specify invoice group numbers to bill subscriptions and order line items based on specific criteria. For the same account, Zuora generates separate invoices for subscriptions and order line items, each identified by unique invoice group numbers. For more information, see [Invoice Grouping](https://knowledgecenter.zuora.com/Billing/Subscriptions/Invoice_Grouping). Note: - If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body and the value of this field is null in the response body. - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request during subscription creation, the value of this field is automatically set to null in the response body. - You can specify this field on a sales order line item when its state (that is, the itemState field) is Executing, Booked, or SentToBilling. - `orderLineItems.sequenceSetId` (string) The ID of the sequence set associated with the order line item. Note: - If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body and the value of this field is null in the response body. - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request during subscription creation, the value of this field is automatically set to null in the response body. - You can specify this field on a sales order line item when its state (that is, the itemState field) is Executing, Booked, or SentToBilling. - `orderLineItems.paymentTerm` (string) The payment term name associated with the order line item. Note: - If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body and the value of this field is null in the response body. - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request during subscription creation, the value of this field is automatically set to null in the response body. - You can specify this field on a sales order line item when its state (that is, the itemState field) is Executing, Booked, or SentToBilling. - `orderLineItems.invoiceTemplateId` (string) The ID of the invoice template associated with the order line item. Note: - If you have the Flexible Billing Attributes feature disabled, this field is unavailable in the request body and the value of this field is null in the response body. - If you have the Flexible Billing Attributes feature enabled, and you do not specify this field in the request during subscription creation, the value of this field is automatically set to null in the response body. - You can specify this field on a sales order line item when its state (that is, the itemState field) is Executing, Booked, or SentToBilling. - `orderLineItems.shipTo` (string) Use this field to assign an existing account as the ship-to contact of an order line item, by the following rules: * If the ownerAccountNumber field is set, then this field must be the ID of a contact that belongs to the owner account of the order line item. * If the ownerAccountNumber field is not set, then this field must be the ID of a contact that belongs to the billing account of the order line item. The billing account is the order account. Note: If an order's category is set to Return in a return Order Line Item, it will inherit the original Order Line Item's shipTo contact automatically. You cannot specify a different value. - `orderLineItems.soldTo` (any) Use this field to assign an existing account as the sold-to contact of an order line item, by the following rules: * If the ownerAccountNumber field is set, then this field must be the ID of a contact that belongs to the owner account of the order line item. * If the ownerAccountNumber field is not set, then this field must be the ID of a contact that belongs to the billing account of the order line item. The billing account is the order account. Note: If an order's category is set to Return in a return Order Line Item, it will inherit the original Order Line Item's soldTo contact automatically. You cannot specify a different value. - `orderLineItems.taxCode` (string) The tax code for the Order Line Item. - `orderLineItems.taxMode` (string) The tax mode for the Order Line Item. Enum: "TaxInclusive", "TaxExclusive" - `orderLineItems.transactionEndDate` (string) The date a transaction is completed. The default value of this field is the transaction start date. Also, the value of this field should always equal or be later than the value of the transactionStartDate field. - `orderLineItems.transactionStartDate` (string) The date a transaction starts. The default value of this field is the order date. - `orderLineItems.unbilledReceivablesAccountingCode` (string) The accounting code on the Order Line Item object for customers using [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration). - `orderNumber` (string) The order number of the new order. If not provided, system will auto-generate a number for this order. Note: The characters #, ?, and / are not allowed in this field. Additionally, to ensure compatibility with the UI when viewing orders, use only the following special characters: _,-, ., ~, *, (, ), and '. - `processingOptions` (object) The container for billing processing options and payment processing options. Note: This field is not supported in draft orders. - `processingOptions.applicationOrder` (array) The priority order to apply credit memos and/or unapplied payments to an invoice. Possible item values are: CreditMemo, UnappliedPayment. Note: - This field is valid only if the applyCredit field is set to true. - If no value is specified for this field, the default priority order is used, ["CreditMemo", "UnappliedPayment"], to apply credit memos first and then apply unapplied payments. - If only one item is specified, only the items of the spedified type are applied to invoices. For example, if the value is ["CreditMemo"], only credit memos are used to apply to invoices. - `processingOptions.applyCredit` (boolean) - If the value is true, the credit memo or unapplied payment on the order account will be automatically applied to the invoices generated by this order. The credit memo generated by this order will not be automatically applied to any invoices Note: This field is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. - `processingOptions.applyCreditBalance` (boolean) Indicates if any credit balance on a customer's account is automatically applied to invoices. If no value is specified then this field defaults to false. This feature is not available if you have enabled the Invoice Settlement feature. - `processingOptions.billingOptions` (object) - `processingOptions.billingOptions.creditMemoReasonCode` (string) A code identifying the reason for the credit memo transaction that is generated by the request. The value must be an existing reason code. If you do not pass the field or pass the field with empty value, Zuora uses the default reason code. - `processingOptions.billingOptions.documentDate` (string) The invoice date displayed on the invoice. - `processingOptions.billingOptions.generateDraftInvoice` (boolean) Indicates if the current request needs to generate a draft invoice. Values are: * true * false (default) - `processingOptions.billingOptions.targetDate` (string) Date through which to calculate charges if an invoice is generated. See [What is a Target Date?](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/G_Bill_Runs/Creating_Bill_Runs#What_is_a_Target_Date.3F). Note: If you do not specify this field, today's date is used by default. - `processingOptions.billingOptions.chargeTypeToExclude` (array) The types of the charges to be excluded from the generation of billing documents. Enum: "OneTime", "Recurring", "Usage" - `processingOptions.collectPayment` (boolean) Indicates if the current request needs to collect payments. This value can not be 'true' when 'runBilling' flag is 'false'. - `processingOptions.electronicPaymentOptions` (object) Container for the electronic payment options. - `processingOptions.electronicPaymentOptions.paymentGatewayId` (string) Specifies the ID of a payment gateway to override the default gateway. If this field is not specified, the default payment gateway will be used to process the payment. - `processingOptions.electronicPaymentOptions.paymentMethodId` (string) Specifies an electronic payment method. It can be one that has already been associated with an invoice owner, or an orphan payment method, which is not associated with any invoice owner. For an orphan payment method, this operation will then associate it with the account that this order will be created under. - `processingOptions.electronicPaymentOptions.gatewayOptions` (object) The field used to pass gateway-specific parameters and parameter values. The fields supported by gateways vary. For more information, see the overview topic of each gateway integration in Zuora Knowledge Center. Zuora sends all the information that you specified to the gateway. If you specify any unsupported gateway option parameters, they will be ignored without error prompts. - `processingOptions.runBilling` (boolean) Indicates if the current request needs to generate an invoice. The invoice will be generated against all subscriptions included in this order. - `reasonCode` (string) Values of reason code configured in Billing Settings > Configure Reason Codes through Zuora UI. Indicates the reason when a return order line item occurs. - `subscriptions` (array) Each item includes a set of order actions, which will be applied to the same base subscription. When you create an order that involves multiple subscriptions, these subscriptions can have different invoice owner accounts or subscription owner accounts. Example: [{"orderActions":[{"type":"CreateSubscription","createSubscription":{"terms":{"initialTerm":{"period":12,"periodType":"Month","termType":"TERMED"},"renewalSetting":"RENEW_WITH_SPECIFIC_TERM","renewalTerms":[{"period":12,"periodType":"Month"}]},"subscribeToRatePlans":[{"productRatePlanId":"8ad081dd9096ef9501909b40bb4e74a4"}]}}]}] - `subscriptions.customFields` (object) Container for custom fields of a Subscription object. - `subscriptions.notes` (string) Notes about the subscription. These notes are only visible to Zuora users. Notes set in this field will override the value of the notes field within the createSubscription order action. - `subscriptions.orderActions` (array) The actions to be applied to the subscription. Order actions will be stored with the sequence when it was provided in the request. - `subscriptions.orderActions.addProduct` (object) Information about an order action of type AddProduct. If you want to create a pending order through the "Add product" order action, and if the charge's trigger condition is Specific Date, you must set a charge number in the chargeNumber field for the "Add product" order action. In this case, if you do not set it, Zuora will not generate the charge number for you. See more information about pending orders in Pending orders and subscriptions. - `subscriptions.orderActions.addProduct.chargeOverrides` (array) List of charges associated with the rate plan. - `subscriptions.orderActions.addProduct.chargeOverrides.accountReceivableAccountingCode` (string) The accountReceivableAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders, Zuora Finance, and Invoice Settlement features are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.adjustmentLiabilityAccountingCode` (string) The adjustmentLiabilityAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders feature and the Billing - Revenue Integration or Order to Revenue feature are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.adjustmentRevenueAccountingCode` (string) The adjustmentRevenueAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders feature and the Billing - Revenue Integration or Order to Revenue feature are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.billing` (object) Billing information about the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.billing.billCycleDay` (integer) Day of the month that each billing period begins on. Only applicable if the value of the billCycleType field is SpecificDayofMonth. - `subscriptions.orderActions.addProduct.chargeOverrides.billing.billCycleType` (string) Specifies how Zuora determines the day that each billing period begins on. * DefaultFromCustomer - Each billing period begins on the bill cycle day of the account that owns the subscription. * SpecificDayofMonth - Use the billCycleDay field to specify the day of the month that each billing period begins on. * SubscriptionStartDay - Each billing period begins on the same day of the month as the start date of the subscription. * ChargeTriggerDay - Each billing period begins on the same day of the month as the date when the charge becomes active. * SpecificDayofWeek - Use the weeklyBillCycleDay field to specify the day of the week that each billing period begins on. Enum: "DefaultFromCustomer", "SpecificDayofMonth", "SubscriptionStartDay", "ChargeTriggerDay", "SpecificDayofWeek" - `subscriptions.orderActions.addProduct.chargeOverrides.billing.billingPeriod` (string) Billing frequency of the charge. The value of this field controls the duration of each billing period. If the value of this field is Specific_Days, Specific_Months or Specific_Weeks, use the specificBillingPeriod field to specify the duration of each billing period. Enum: "Month", "Quarter", "Semi_Annual", "Annual", "Eighteen_Months", "Two_Years", "Three_Years", "Five_Years", "Specific_Months", "Subscription_Term", "Week", "Specific_Weeks", "Specific_Days" - `subscriptions.orderActions.addProduct.chargeOverrides.billing.billingPeriodAlignment` (string) Specifies how Zuora determines when to start new billing periods. You can use this field to align the billing periods of different charges. * AlignToCharge - Zuora starts a new billing period on the first billing day that falls on or after the date when the charge becomes active. * AlignToSubscriptionStart - Zuora starts a new billing period on the first billing day that falls on or after the start date of the subscription. * AlignToTermStart - For each term of the subscription, Zuora starts a new billing period on the first billing day that falls on or after the start date of the term. See the billCycleType field for information about how Zuora determines the billing day. Note: This field is not supported in one time charges. Enum: "AlignToCharge", "AlignToSubscriptionStart", "AlignToTermStart" - `subscriptions.orderActions.addProduct.chargeOverrides.billing.billingTiming` (string) Specifies whether to invoice for a billing period on the first day of the billing period (billing in advance) or the first day of the next billing period (billing in arrears). Enum: "IN_ADVANCE", "IN_ARREARS" - `subscriptions.orderActions.addProduct.chargeOverrides.billing.specificBillingPeriod` (integer) Duration of each billing period in months or weeks, depending on the value of the billingPeriod field. Only applicable if the value of the billingPeriod field is Specific_Months or Specific_Weeks. - `subscriptions.orderActions.addProduct.chargeOverrides.billing.weeklyBillCycleDay` (string) Day of the week that each billing period begins on. Only applicable if the value of the billCycleType field is SpecificDayofWeek. Enum: "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" - `subscriptions.orderActions.addProduct.chargeOverrides.chargeFunction` (string) Note: This field is only available if you have both the Prepaid with Drawdown and Standalone Orders features enabled. With this field, you can use a standalone order to subscribe to a minimum commitment subscription. This field defines what type of charge it is: * CommitmentTrueUp: For recurring charges. Currency based minimum commitment charge. * CreditCommitment: For usage charges. Credit to minimum commitment funds. Enum: "CommitmentTrueUp", "CreditCommitment" - `subscriptions.orderActions.addProduct.chargeOverrides.commitmentType` (string) Note: This field is only available if you have both the Prepaid with Drawdown and Standalone Orders features enabled. With this field, you can use a standalone order to subscribe to a minimum commitment subscription. This field defines the type of the commitment for both the commitment true-up charge and credit commitment charge, and so you must define the type as CURRENCY. Enum: "CURRENCY" - `subscriptions.orderActions.addProduct.chargeOverrides.creditOption` (string) Note: This field is only available if you have both the Minimum Commitment and Standalone Orders features enabled. With this field, you can use a standalone order to subscribe to a minimum commitment subscription. This field defines the way to calculate credit. See [Credit Option](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge#Credit_Option) for more information. Enum: "TimeBased", "ConsumptionBased", "FullCreditBack" - `subscriptions.orderActions.addProduct.chargeOverrides.chargeModel` (string) The chargeModel of a standalone charge. Supported charge models: * FlatFee * PerUnit * Volume * Tiered * DiscountFixedAmount * DiscountPercentage Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.chargeNumber` (string) Charge number of the charge. For example, C-00000307. * If you do not set this field, Zuora will generate a charge number starting with a default prefix, for example, C-. This default prefix is predefined in Billing Settings > Define Default Subscription and Order Settings. * If you want to use a custom charge number, do not use the default prefix predefined in Billing Settings > Define Default Subscription and Order Settings. Use your own prefix, for example, SC-. - `subscriptions.orderActions.addProduct.chargeOverrides.chargeType` (string) The chargeType of a standalone charge. Supported charge types: * OneTime * Recurring * Usage Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.contractAssetAccountingCode` (string) The contractAssetAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders feature and the Billing - Revenue Integration or Order to Revenue feature are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.contractLiabilityAccountingCode` (string) The contractLiabilityAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders feature and the Billing - Revenue Integration or Order to Revenue feature are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.contractRecognizedRevenueAccountingCode` (string) The contractRecognizedRevenueAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders feature and the Billing - Revenue Integration or Order to Revenue feature are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.customFields` (object) Container for custom fields of a Rate Plan Charge object. - `subscriptions.orderActions.addProduct.chargeOverrides.deferredRevenueAccountingCode` (string) The deferredRevenueAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders and Zuora Finance features are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.description` (string) Description of the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.drawdownRate` (number) Note: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. The [conversion rate](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_drawdown_charge#UOM_Conversion) between Usage UOM and Drawdown UOM for a [drawdown charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_drawdown_charge). Must be a positive number (>0). - `subscriptions.orderActions.addProduct.chargeOverrides.endDate` (object) Specifies when a charge becomes inactive. - `subscriptions.orderActions.addProduct.chargeOverrides.endDate.endDateCondition` (string) Condition for the charge to become inactive. - If the value of this field is Fixed_Period, the charge is active for a predefined duration based on the value of the upToPeriodsType and upToPeriods fields. - If the value of this field is Specific_End_Date, use the specificEndDate field to specify the date when the charge becomes inactive. Enum: "Subscription_End", "Fixed_Period", "Specific_End_Date" - `subscriptions.orderActions.addProduct.chargeOverrides.endDate.endDatePolicy` (string) End date policy of the discount charge to become active when the Apply to billing period partially checkbox is selected from the product catalog UI or the applyToBillingPeriodPartially field is set as true from the "CRUD: Create a product rate plan charge" operation. - If the value of this field is FixedPeriod, the charge is active for a predefined duration based on the value of the upToPeriodsType and upToPeriods fields. - If the value of this field is SpecificEndDate, use the specificEndDate field to specify the date when the charge becomes inactive. Notes: - You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. - You can use either endDateCondition or endDatePolicy to define when a discount charge ends, but not both at the same time. Enum: "AlignToApplyToCharge", "SpecificEndDate", "FixedPeriod" - `subscriptions.orderActions.addProduct.chargeOverrides.endDate.specificEndDate` (string) Date in YYYY-MM-DD format. Only applicable if the value of the endDateCondition field is Specific_End_Date. - `subscriptions.orderActions.addProduct.chargeOverrides.endDate.upToPeriods` (integer) Duration of the charge in billing periods, days, weeks, months, or years, depending on the value of the upToPeriodsType field. Only applicable if the value of the endDateCondition field is Fixed_Period. - `subscriptions.orderActions.addProduct.chargeOverrides.endDate.upToPeriodsType` (string) Unit of time that the charge duration is measured in. Only applicable if the value of the endDateCondition field is Fixed_Period. Enum: "Billing_Periods", "Days", "Weeks", "Months", "Years" - `subscriptions.orderActions.addProduct.chargeOverrides.estimatedStartDate` (string) The estimated start date of the pending charge in an active subscription. If you specify SpecificDate in the startDate > triggerEvent field and want to create a completed order and an active subscription, you must specify either the estimatedStartDate or startDate > specificTriggerDate field: - estimatedStartDate: The charge will be in pending status. - specificTriggerDate: The charge will be in active status. The value of this field must be a date within the subscription term. The system will then automatically calculate the estimated end date for the pending charge. The estimated start and end dates are used to manage the estimated charge duration and forecast the revenue for the pending charge. Note: This field is available only when the Pending Subscription Processing feature is turned on. - `subscriptions.orderActions.addProduct.chargeOverrides.excludeItemBillingFromRevenueAccounting` (boolean) The flag to exclude rate plan charge related invoice items, invoice item adjustments, credit memo items, and debit memo items from revenue accounting. If both the following features are enabled in your tenant, you must ensure the excludeItemBillingFromRevenueAccounting field is set consistently for a prepayment charge and the corresponding drawdown charge. In addition, if the excludeItemBookingFromRevenueAccounting field in a Create Subscription or Add Product order action is set to false, you must also set the excludeItemBillingFromRevenueAccounting field in this order action to false. * Prepaid with Drawdown * Unbilled Usage Note: This field is only available if you have the Order to Revenue or [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration) feature enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.excludeItemBookingFromRevenueAccounting` (boolean) The flag to exclude rate plan charges from revenue accounting. If both the following features are enabled in your tenant, you must ensure the excludeItemBookingFromRevenueAccounting field is set consistently for a prepayment charge and the corresponding drawdown charge. * Prepaid with Drawdown * Unbilled Usage Note: This field is only available if you have the Order to Revenue or [Zuora Billing - Revenue Integration](https://knowledgecenter.zuora.com/Zuora_Revenue/Zuora_Billing_-_Revenue_Integration) feature enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.isRollover` (boolean) Note: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. The value is either "True" or "False". It determines whether the rollover fields are needed. - `subscriptions.orderActions.addProduct.chargeOverrides.name` (string) The name of a standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.negotiatedPriceTable` (array) Array of negotiated price table information. The rate card entries provided in the array will override the existing rate card entries in the standard price table to form a negotiated price table that will be used during pricing evaluation. Note: To enable the Negotiated Price Table feature, submit a request to Zuora Global Support. - `subscriptions.orderActions.addProduct.chargeOverrides.negotiatedPriceTable.items` (object) The rate card entry object. Note: For more information, refer to the rate card definition in the product catalog. - `subscriptions.orderActions.addProduct.chargeOverrides.pobPolicy` (string) The pobPolicy of a standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.prepaidQuantity` (number) Note: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. The number of units included in a [prepayment charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge). Must be a positive number (>0). - `subscriptions.orderActions.addProduct.chargeOverrides.pricing` (object) Pricing information about the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData` (object) Container for charge model configuration data. Note: This field is only available if you have the High Water Mark, Pre-Rated Pricing, or Multi-Attribute Pricing charge models enabled. The High Water Mark and Pre-Rated Pricing charge models are available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://docs.zuora.com/en/entitlements/current-entitlements/zuora-editions) for pricing information. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.chargeModelConfiguration` (object) - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.chargeModelConfiguration.customFieldPerUnitRate` (string) The custom field that carries the per-unit rate for each usage record. For example, perUnitAmount__c. This field is only available for the usage-based charges that use the Pre-Rated Per Unit Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://docs.zuora.com/en/entitlements/current-entitlements/zuora-editions) for pricing information. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.chargeModelConfiguration.customFieldTotalAmount` (string) The custom field that carries the total amount to charge for a usage record. For example, totalAmount__c. This field is only available for the usage-based charges that use the Pre-Rated Pricing charge model. The charge model is available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://docs.zuora.com/en/entitlements/current-entitlements/zuora-editions) for pricing information. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.chargeModelConfiguration.formula` (string) The pricing formula to calculate actual rating amount. This field is only available for charges that use the Multi-Attribute Pricing charge model. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.quantity` (number) Number of units purchased. This field is used if the Multi-Attribute Pricing formula uses the quantity() function. This field is only available for one-time and recurring charges that use the Multi-Attribute Pricing charge model. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers` (array) List of cumulative pricing tiers in the charge. Note: When you override the tiers of a usage-based charge using High Water Mark Pricing charge model, you have to provide all of the tiers, including the ones you do not want to change. The new tiers will completely override the previous ones. The High Water Mark Pricing charge models are available for customers with Enterprise and Nine editions by default. If you are a Growth customer, see [Zuora Editions](https://docs.zuora.com/en/entitlements/current-entitlements/zuora-editions) for pricing information. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers.endingUnit` (number) Limit on the number of units for which the tier is effective. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers.originalListPrice` (number) The original list price is the price of a product or service at which it is listed for sale by a manufacturer or retailer. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers.price` (number, required) Price or per-unit price of the tier, depending on the value of the priceFormat field. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers.priceFormat` (string, required) Specifies whether the tier has a fixed price or a per-unit price. Enum: "FlatFee", "PerUnit" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers.startingUnit` (number, required) Number of units at which the tier becomes effective. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.chargeModelData.tiers.tier` (integer, required) Index of the tier in the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount` (object) Pricing information about a discount charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.applyDiscountTo` (string) Specifies which type of charge the discount charge applies to. Enum: "ONETIME", "RECURRING", "USAGE", "ONETIMERECURRING", "ONETIMEUSAGE", "RECURRINGUSAGE", "ONETIMERECURRINGUSAGE" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.applyToBillingPeriodPartially` (boolean) Allow the discount duration to be aligned with the billing period partially. Note: You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountAmount` (number) Only applicable if the discount charge is a fixed-amount discount. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountApplyDetails` (array) Charge list of discount be applied to. Note: You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountApplyDetails.productRatePlanChargeId` (string, required) Product Rate Plan Charge Id of the discount apply to. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountApplyDetails.productRatePlanId` (string, required) Product Rate Plan Id of the discount apply to. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountClass` (string) The discount class defines the sequence in which discount product rate plan charges are applied. Note: You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountLevel` (string) Application scope of the discount charge. For example, if the value of this field is subscription and the value of the applyDiscountTo field is RECURRING, the discount charge applies to all recurring charges in the same subscription as the discount charge. Enum: "rateplan", "subscription", "account" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.discountPercentage` (number) Only applicable if the discount charge is a percentage discount. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.originalDiscountAmount` (number) The manufacturer's suggested retail discount price for standalone charge. Only applicable if the standalone discount charge is a fixed-amount discount. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.originalDiscountPercentage` (number) The manufacturer's suggested retail discount percentage for standalone charge. Only applicable if the standalone discount charge is a percentage discount. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.discount.priceChangeOption` (string) Specifies how Zuora changes the price of the charge each time the subscription renews. Enum: "NoChange", "UseLatestProductCatalogPricing" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimeFlatFee` (object) Pricing information about a one-time charge that uses the "flat fee" charge model. In this charge model, the charge has a fixed price. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimeFlatFee.listPrice` (number, required) Price of the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimePerUnit` (object) Pricing information about a one-time charge that uses the "per unit" charge model. In this charge model, the charge has a fixed price per unit purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimePerUnit.listPrice` (number) Per-unit price of the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimePerUnit.quantity` (number) Number of units purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimePerUnit.uom` (number) Unit of measure of the standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimeTiered` (object) Pricing information about a one-time charge that uses the "tiered pricing" charge model. In this charge model, the charge has cumulative pricing tiers that become effective as units are purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimeTiered.tiers` (array) List of cumulative pricing tiers in the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimeVolume` (object) Pricing information about a one-time charge that uses the "volume pricing" charge model. In this charge model, the charge has a variable price per unit, depending on how many units are purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.oneTimeVolume.tiers` (array) List of variable pricing tiers in the charge. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased` (object) Pricing information about a recurring charge that uses the Delivery Pricing charge model. In this charge model, the charge has a fixed price. This field is only available if you have the Delivery Pricing charge model enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.priceChangeOption` (string) Specifies how Zuora changes the price of the charge each time the subscription renews. If the value of this field is SpecificPercentageValue, use the priceIncreasePercentage field to specify how much the price of the charge should change. Enum: "NoChange", "SpecificPercentageValue", "UseLatestProductCatalogPricing" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.priceIncreasePercentage` (number) Specifies the percentage by which the price of the charge should change each time the subscription renews. Only applicable if the value of the priceChangeOption field is SpecificPercentageValue. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule` (object) - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.frequency` (string) Specifies the frequency for delivery schedule Enum: "Weekly" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.friday` (boolean) Indicates whether delivery on friday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.monday` (boolean) Indicates whether delivery on monday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.saturday` (boolean) Indicates whether delivery on saturday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.sunday` (boolean) Indicates whether delivery on sunday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.thursday` (boolean) Indicates whether delivery on thursday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.tuesday` (boolean) Indicates whether delivery on tuesday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.deliverySchedule.wednesday` (boolean) Indicates whether delivery on wednesday. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringDeliveryBased.listPrice` (number) Price of the charge in each recurring period. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringFlatFee` (object) Pricing information about a recurring charge that uses the "flat fee" charge model. In this charge model, the charge has a fixed price. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringFlatFee.listPriceBase` (string) Specifies the duration of each recurring period. Enum: "Per_Billing_Period", "Per_Month", "Per_Week", "Per_Year", "Per_Specific_Months" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringFlatFee.specificListPriceBase` (integer) The number of months for the list price base of the charge. This field is required if you set the value of the listPriceBase field to Per_Specific_Months. Note: - This field is available only if you have the Annual List Price feature enabled. - The value of this field is null if you do not set the value of the listPriceBase field to Per_Specific_Months. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringPerUnit` (object) Pricing information about a recurring charge that uses the "per unit" charge model. In this charge model, the charge has a fixed price per unit purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringPerUnit.listPrice` (number) Per-unit price of the charge in each recurring period. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringTiered` (object) Pricing information about a recurring charge that uses the "tiered pricing" charge model. In this charge model, the charge has cumulative pricing tiers that become effective as units are purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.recurringVolume` (object) Pricing information about a recurring charge that uses the "volume pricing" charge model. In this charge model, the charge has a variable price per unit, depending on how many units are purchased. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageFlatFee` (object) Pricing information about a usage charge that uses the "flat fee" charge model. In this charge model, the charge has a fixed price. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageOverage` (object) Pricing information about a usage charge that uses the "overage" charge model. In this charge model, the charge has an allowance of free units and a fixed price per additional unit consumed. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageOverage.includedUnits` (number) Number of free units that may be consumed. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageOverage.numberOfPeriods` (integer) Number of periods that Zuora considers when calculating overage charges with overage smoothing. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageOverage.overagePrice` (number) Price per overage unit consumed. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageOverage.overageUnusedUnitsCreditOption` (string) Specifies whether to credit the customer for unused units. If the value of this field is CreditBySpecificRate, use the unusedUnitsCreditRates field to specify the rate at which to credit the customer for unused units. Enum: "NoCredit", "CreditBySpecificRate" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageOverage.unusedUnitsCreditRates` (number) Per-unit rate at which to credit the customer for unused units. Only applicable if the value of the overageUnusedUnitsCreditOption field is CreditBySpecificRate. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usagePerUnit` (object) Pricing information about a usage charge that uses the "per unit" charge model. In this charge model, the charge has a fixed price per unit consumed. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usagePerUnit.ratingGroup` (string) Specifies how Zuora groups usage records when rating usage. See [Usage Rating by Group](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Usage/Usage_Rating_by_Group) for more information. * ByBillingPeriod (default): The rating is based on all the usages in a billing period. * ByUsageStartDate: The rating is based on all the usages on the same usage start date. * ByUsageRecord: The rating is based on each usage record. * ByUsageUpload: The rating is based on all the usages in a uploaded usage file (.xls or .csv). If you import a mass usage in a single upload, which contains multiple usage files in .xls or .csv format, usage records are grouped for each usage file. Enum: "ByBillingPeriod", "ByUsageStartDate", "ByUsageRecord", "ByUsageUpload" - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageTiered` (object) Pricing information about a usage charge that uses the "tiered pricing" charge model. In this charge model, the charge has cumulative pricing tiers that become effective as units are consumed. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageTieredWithOverage` (object) Pricing information about a usage charge that uses the "tiered with overage" charge model. In this charge model, the charge has cumulative pricing tiers that become effective as units are consumed. The charge also has a fixed price per unit consumed beyond the limit of the final tier. - `subscriptions.orderActions.addProduct.chargeOverrides.pricing.usageVolume` (object) Pricing information about a usage charge that uses the "volume pricing" charge model. In this charge model, the charge has a variable price per unit, depending on how many units are consumed. - `subscriptions.orderActions.addProduct.chargeOverrides.pricingAttributes` (object) Container for pricing attribute and value that provide additional context for dynamic pricing. The pricing attribute values are used to get the charge’s list price from the product catalog. For the pricing attribute mapped to a Zuora object field, Zuora will retrieve the value automatically, you don’t need to pass its value explicitly. If you pass a value that doesn’t match the actual value of the Zuora object, an error will be returned. Note that for any pricing attribute mapped to the field of Zuora object Usage, because its value is only determined when the usage record arrives, you can’t provide a value via Orders API payload and Zuora will not retrieve its value automatically. Note: To enable Dynamic Pricing, submit a request to Zuora Global Support. - `subscriptions.orderActions.addProduct.chargeOverrides.productCategory` (string) The productCategory of a standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.productClass` (string) The productClass of a standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.productFamily` (string) The productFamily of a standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.productLine` (string) The productLine of a standalone charge. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.productRatePlanChargeId` (string, required) Internal identifier of the product rate plan charge that the charge is based on. You can specify either productRatePlanChargeId or productRatePlanChargeNumber. When isAddingSubsetCharges is set to true, the product rate charge specified by productRatePlanChargeId is added to the existing rate plan specified by ratePlanId. - `subscriptions.orderActions.addProduct.chargeOverrides.productRatePlanChargeNumber` (string) Number of a product rate-plan charge for this subscription. You can specify either productRatePlanChargeId or productRatePlanChargeNumber. - `subscriptions.orderActions.addProduct.chargeOverrides.prorationOption` (string) Note: This field is only available if you have the Charge Level Proration feature enabled. For more information, see Usage charge proration and Charge level proration option for a recurring charge. You can use this field to specify the charge-level proration option for a usage charge or recurring charge when you creating or adding a subscription rate plan charge through an order. The tenant-level proration option will be overridden. * NoProration: charge-level proration option that you can set for a usage charge. This option means to not use any proration, which is the default current system behavior for a usage charge. * TimeBasedProration: charge-level proration option that you can set for a usage charge. This option means to prorate the usage charge amount using the actual number of days if the billing period is a partial period. * DefaultFromTenantSetting: charge-level proration option that you can set for a recurring charge. This option means to follow the customer billing rule proration setting. * ChargeFullPeriod: charge-level proration option that you can set for a recurring charge. This options means to charge the full period amount for a partial billing period. Note that this setting means that there is no proration for either collecting or refunding. Even if you cancel the recurring charge in the middle of a billing period, there is no refund for this billing period. * CustomizeProrationOptionOverrides: charge-level proration option that you can set for a recurring charge. This option means to use the customized charge proration settings that is specified by the ratingPropertiesOverride field. Enum: "NoProration", "TimeBasedProration", "DefaultFromTenantSetting", "ChargeFullPeriod", "CustomizeProrationOptionOverrides" - `subscriptions.orderActions.addProduct.chargeOverrides.ratingPropertiesOverride` (object) Note: This field is only available if you have the Charge Level Proration feature enabled. For more information, see Charge level proration option for a recurring charge. This field is used only when the value of the prorationOption field is set to CustomizeProrationOptionOverrides. Use this field to specify more customized proration options for a recurring charge when you creating or adding a subscription rate plan charge through an order. The tenant-level proration option will be overridden. - `subscriptions.orderActions.addProduct.chargeOverrides.ratingPropertiesOverride.isProratePartialMonth` (boolean) Note: This field is only available if you have the Charge Level Proration feature enabled. For more information, see Charge level proration option for a recurring charge. Use this field to specify whether to prorate the recurring charge for a partial month. The tenant-level proration option will be overridden. - `subscriptions.orderActions.addProduct.chargeOverrides.ratingPropertiesOverride.prorationUnit` (string) Note: This field is only available if you have the Charge Level Proration feature enabled. For more information, see Charge level proration option for a recurring charge. Use this field to specify the unit of proration for a recurring charge. The tenant-level proration option will be overridden. Enum: "ProrateByDay", "ProrateByMonthFirst" - `subscriptions.orderActions.addProduct.chargeOverrides.ratingPropertiesOverride.daysInMonth` (string) Note: This field is only available if you have the Charge Level Proration feature enabled. For more information, see Charge level proration option for a recurring charge. Use this field to specify the number of days counted for a month when prorating a recurring charge. The tenant-level proration option will be overridden. See more details for each of the following enum values in Proration. Enum: "UseActualDays", "Assume30Days", "Assume30DaysStrict" - `subscriptions.orderActions.addProduct.chargeOverrides.recognizedRevenueAccountingCode` (string) The recognizedRevenueAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders and Zuora Finance features are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.revRecCode` (string) Revenue Recognition Code - `subscriptions.orderActions.addProduct.chargeOverrides.revRecTriggerCondition` (string) Specifies the revenue recognition trigger condition. * Contract Effective Date * Service Activation Date * Customer Acceptance Date Enum: "Contract Effective Date", "Service Activation Date", "Customer Acceptance Date" - `subscriptions.orderActions.addProduct.chargeOverrides.revenueRecognitionRuleName` (string) Specifies the revenue recognition rule, such as Recognize upon invoicing or Recognize daily over time. - `subscriptions.orderActions.addProduct.chargeOverrides.revenueRecognitionTiming` (string) Specifies the type of revenue recognition timing. Predefined options are listed as enum values in this API Reference. Other options might also be avaliable depending on the revenue recognition policy configuration in the Zuora Billing UI. Note: This field is only available if you have both the Order to Revenue feature and the Standalone Orders feature enabled. Enum: "Upon Billing Document Posting Date", "Upon Order Activation Date" - `subscriptions.orderActions.addProduct.chargeOverrides.revenueAmortizationMethod` (string) Specifies the type of revenue amortization method. Predefined options are listed as enum values in this API Reference. Other options might also be avaliable depending on the revenue recognition policy configuration in the Zuora Billing UI. Note: This field is only available if you have both the Order to Revenue feature and the Standalone Orders feature enabled. Enum: "Immediate", "Ratable Using Start And End Dates" - `subscriptions.orderActions.addProduct.chargeOverrides.rolloverApply` (string) Note: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. This field defines the priority of rollover, which is either first or last. Enum: "ApplyFirst", "ApplyLast" - `subscriptions.orderActions.addProduct.chargeOverrides.rolloverPeriodLength` (integer) Note: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. Use this field when you want to set the rollover fund's period length shorter than the prepayment charge's validity period. In this case, you must set the rolloverPeriods field to 1. For example, you can define the rollover fund's period length as 5 months, shorter than the prepayment charge's validity period: a year. - `subscriptions.orderActions.addProduct.chargeOverrides.rolloverPeriods` (number) Note: This field is only available if you have the [Prepaid with Drawdown](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown) feature enabled. This field defines the number of rollover periods, it is restricted to 3. - `subscriptions.orderActions.addProduct.chargeOverrides.startDate` (object) Specifies when a charge becomes active. - `subscriptions.orderActions.addProduct.chargeOverrides.startDate.periodsAfterChargeStart` (integer) Duration of the discount charge in days, weeks, months, or years, depending on the value of the startPeriodsType field. Only applicable if the value of the startDatePolicy field is FixedPeriodAfterApplyToChargeStartDate. Note: You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. - `subscriptions.orderActions.addProduct.chargeOverrides.startDate.specificTriggerDate` (string) Date in YYYY-MM-DD format. Only applicable if the value of the triggerEvent field is SpecificDate. While this field is applicable, if this field is not set, your CreateSubscription order action creates a Pending order and a Pending Acceptance subscription. If at the same time the service activation date is required and not set, a Pending Activation subscription is created. While this field is applicable, if this field is not set, the following order actions create a Pending order but do not impact the subscription status. Note: This feature is in Limited Availability. If you want to have access to the feature, submit a request at [Zuora Global Support](http://support.zuora.com/). * AddProduct * UpdateProduct * RemoveProduct * RenewSubscription * TermsAndConditions - `subscriptions.orderActions.addProduct.chargeOverrides.startDate.startDatePolicy` (string) Start date policy of the discount charge to become active when the Apply to billing period partially checkbox is selected from the product catalog UI or the applyToBillingPeriodPartially field is set as true from the "CRUD: Create a product rate plan charge" operation. - If the value of this field is SpecificDate, use the specificTriggerDate field to specify the date when the charge becomes active. - If the value of this field is FixedPeriodAfterApplyToChargeStartDate, the charge is active for a predefined duration based on the value of the upToPeriodsType and upToPeriods fields. Notes: - You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. - You can use either triggerEvent or startDatePolicy to define when a discount charge starts, but not both at the same time. Enum: "AlignToApplyToCharge", "SpecificDate", "EndOfLastInvoicePeriodOfApplyToCharge", "FixedPeriodAfterApplyToChargeStartDate" - `subscriptions.orderActions.addProduct.chargeOverrides.startDate.startPeriodsType` (string) Unit of time that the discount charge duration is measured in. Only applicable if the value of the startDatePolicy field is FixedPeriodAfterApplyToChargeStartDate. Note: You must enable the [Enhanced Discounts](https://knowledgecenter.zuora.com/Zuora_Billing/Build_products_and_prices/Basic_concepts_and_terms/B_Charge_Models/D_Manage_Enhanced_Discount) feature to access this field. Enum: "Days", "Weeks", "Months", "Years" - `subscriptions.orderActions.addProduct.chargeOverrides.startDate.triggerEvent` (string) Condition for the charge to become active. If the value of this field is SpecificDate, use the specificTriggerDate field to specify the date when the charge becomes active. Enum: "ContractEffective", "ServiceActivation", "CustomerAcceptance", "SpecificDate" - `subscriptions.orderActions.addProduct.chargeOverrides.taxCode` (string) The tax code of a charge. This field is available when the taxable field is set to true. - `subscriptions.orderActions.addProduct.chargeOverrides.taxMode` (string) The tax mode of a charge. This field is available when the taxable field is set to true. Enum: "TaxExclusive", "TaxInclusive" - `subscriptions.orderActions.addProduct.chargeOverrides.taxable` (boolean) The flag indicates whether the charge is taxable. If this field is set to true, you must specify the taxCode and taxMode fields. - `subscriptions.orderActions.addProduct.chargeOverrides.unBilledReceivablesAccountingCode` (string) The unBilledReceivablesAccountingCode of a standalone charge. Note: This field is available when the Standalone Orders feature and the Billing - Revenue Integration or Order to Revenue feature are enabled. - `subscriptions.orderActions.addProduct.chargeOverrides.uniqueToken` (string) Unique identifier for the charge. This identifier enables you to refer to the charge before the charge has an internal identifier in Zuora. For instance, suppose that you want to use a single order to add a product to a subscription and later update the same product. When you add the product, you can set a unique identifier for the charge. Then when you update the product, you can use the same unique identifier to specify which charge to modify. - `subscriptions.orderActions.addProduct.chargeOverrides.upsellOriginChargeNumber` (string) The identifier of the original upselling charge associated with the current charge. For a termed subscription, you can now use the "Create an order" API operation to perform an Add Product order action to make a product quantity upsell for per unit recurring charges. The benefit is that the charge added by this approach will be automatically combined with the original existing charge for which you want to upsell when the subscription is renewed. The approach is as follows: * Use an Add Product order action to add a charge that is of the same charge type, charge model, and charge end date as the existing per unit recurring charge for which you want to make a quantity upsell. * In the preceding charge to add, use the upsellOriginChargeNumber field to specify the existing rate plan charge for which you want to make the quantity upsell. Note that a termed subscription with such upsell charges can not be changed to an evergreen subscription. Note: The Quantity Upsell feature is in the Early Adopter phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you want to join this early adopter program, submit a request at [Zuora Global Support](https://support.zuora.com). - `subscriptions.orderActions.addProduct.chargeOverrides.validityPeriodType` (string) Note: This field is only available if you have enabled either of the following: * Prepaid with Drawdown * Minimum Commitment * Both Minimum Commitment and Standalone Orders You can use this field in the following scenarios: * When you create a [prepayment charge](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/J_Billing_Operations/Prepaid_with_Drawdown/Create_prepayment_charge), use this field to define the period in which the prepayment units are valid to use. * When you override the setting of commitment true-up charge from the product catalog, set this field consistently with the value of the billing > billingPeriod field in this charge. * When you use a standalone order to create a commitment true-up charge, set this field consistently with the value of the billing > billingPeriod field in this charge. Enum: "SUBSCRIPTION_TERM", "ANNUAL", "SEMI_ANNUAL", "QUARTER", "MONTH" - `subscriptions.orderActions.addProduct.clearingExistingFeatures` (boolean) Specifies whether all features in the rate plan will be cleared. - `subscriptions.orderActions.addProduct.customFields` (object) Container for custom fields of the Rate Plan object. The custom fields of the Rate Plan object are used when rate plans are subscribed. - `subscriptions.orderActions.addProduct.externalCatalogPlanId` (string) An external ID of the product rate plan to be added. You can use this field to specify a product rate plan that is imported from an external system. The value of the externalCatalogPlanId field must match one of the values that are predefined in the externallyManagedPlanIds field on a product rate plan. Note: If both externalCatalogPlanId and productRatePlanId are provided. They must point to the same product rate plan. Otherwise, the request would fail. - `subscriptions.orderActions.addProduct.externallyManagedPlanId` (string) Indicates the unique identifier for the rate plan purchased on a third-party store. This field is used to represent a subscription rate plan created through third-party stores. - `subscriptions.orderActions.addProduct.isAddingSubsetCharges` (boolean) Specifies whether to add a subset of charges to the subscription. Note: To access this field for adding a subset of charges, submit a request at Zuora Global Support. - `subscriptions.orderActions.addProduct.isFromExternalCatalog` (boolean) Indicates whether the rate plan is created from the Zuora product catalog or from an external product catalog. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.productRatePlanId` (string) Internal identifier of the product rate plan that the rate plan is based on. - `subscriptions.orderActions.addProduct.productRatePlanNumber` (string) Number of a product rate plan for this subscription. - `subscriptions.orderActions.addProduct.ratePlanName` (string) Name of the standalone rate plan. Note: This field is available when the Standalone Orders feature is enabled. - `subscriptions.orderActions.addProduct.subscriptionProductFeatures` (array) List of features associated with the rate plan. The system compares the subscriptionProductFeatures and featureId fields in the request with the counterpart fields in a rate plan. The comparison results are as follows: * If there is no subscriptionProductFeatures field or the field is empty, features in the rate plan remain unchanged. But if the clearingExistingFeatures field is additionally set to true, all features in the rate plan are cleared. * If the subscriptionProductFeatures field contains the featureId nested fields, as well as the optional description and customFields nested fields, the features indicated by the featureId nested fields in the request overwrite all features in the rate plan. - `subscriptions.orderActions.addProduct.subscriptionProductFeatures.customFields` (object) A container for custom fields of the feature. - `subscriptions.orderActions.addProduct.subscriptionProductFeatures.description` (string) A description of the feature. - `subscriptions.orderActions.addProduct.subscriptionProductFeatures.featureId` (string, required) Internal identifier of the feature in the product catalog. - `subscriptions.orderActions.addProduct.subscriptionRatePlanNumber` (string) Number of a subscription rate plan for this subscription. - `subscriptions.orderActions.addProduct.uniqueToken` (string) Unique identifier for the rate plan. This identifier enables you to refer to the rate plan before the rate plan has 
[...]
